Imports System.Xml
Public Class TextEintrag
    Inherits ChangeListItem

    Private m_Wichtig As Boolean = False
    Private m_Text As String = ""
    Private m_Parent As TextEintragsListe
    Public Sub New(ByVal Parent As TextEintragsListe)
        m_Parent = Parent
    End Sub

    Public Sub New(ByVal Parent As TextEintragsListe, ByVal Nd As XmlNode)
        m_Parent = Parent
        m_Wichtig = CBool(Nd.Attributes("wichtig").Value)
        m_Text = Nd.Attributes("Text").Value
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("wichtig", m_Wichtig.ToString)
        Writer.WriteAttributeString("Text", m_Text)
    End Sub

    Property Wichtig() As Boolean
        Get
            Return m_Wichtig
        End Get
        Set(ByVal value As Boolean)
            m_Wichtig = value
            m_Parent.RaiseChanged("Wichtig")
        End Set
    End Property
    Property Text() As String
        Get
            Return m_Text
        End Get
        Set(ByVal value As String)
            m_Text = value.Trim
        End Set
    End Property
    Public Sub ValidateText()
        m_Parent.RaiseChanged("Text")
        m_Parent.ValidateForNewItem()
    End Sub

    Public Overrides Function IsEmpty() As Boolean
        If m_Text.Trim = "" Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Overloads Overrides Function CreateControl(ByVal Editor As EintragsEditor) As IEditorControlItem
        Return New TextEintragEditorItem(Editor, Me)
    End Function
End Class
